<template>
  <div>
    <v-data-table
      calculate-widths
      :headers="permission ? headers : headers2"
      :items="answers"
      :footer-props="{
        itemsPerPageText: 'Respostas por página',
      }"
      class="elevation-0"
    >
      <template v-slot:top>
        <v-row justify="center" id="cardTitle" class="pb-3">
          Tópicos de respostas enviados ({{ answers.length }})</v-row
        >
        <v-toolbar flat color="white">
          <v-col class="navCollaborativeWorkOption" cols="12">
            <v-btn
              v-if="permission"
              color="primary"
              elevation="0"
              small
              @click="downloadAnswers"
              :disabled="answers.length === 0"
              >Baixar todos Anexos<v-icon class="pl-2" small>mdi-download</v-icon></v-btn
            >
          </v-col>
        </v-toolbar>
      </template>
      <!-- template icones -->
      <template v-slot:[`item.action`]="{ item }">
        <div class="hoverCollaborative">
          <v-tooltip bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" class="mr-2" small @click="viewAnswer(item)">mdi-eye</v-icon>
            </template>
            <span><b>Ver</b> resposta</span>
          </v-tooltip>
          <v-tooltip v-if="checkIsVisible(item) || permission" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" class="mr-2" small @click="openDialogViewTeam(item)"
                >mdi-account-group</v-icon
              >
            </template>
            <span><b>Gerenciar</b> Equipe</span>
          </v-tooltip>
          <v-tooltip v-if="checkIsVisible(item) || permission" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" class="mr-2" small @click="viewAnswerAttachment(item)"
                >mdi-paperclip</v-icon
              >
            </template>
            <span><b>Gerenciar</b> Anexo da Resposta</span>
          </v-tooltip>
          <v-tooltip v-if="permission" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="openDelete(item)">mdi-delete</v-icon>
            </template>
            <span><b>Deletar</b> tópico de resposta</span>
          </v-tooltip>
        </div>
      </template>
      <!-- nome do time -->
      <template v-slot:[`item.team`]="{ item }">
        <div v-for="(user, index) in item.participants" :key="index">
          <span
            small
            style="font-size: 0.8rem"
            :class="index + 1 == item.participants.length ? 'my-1' : 'mt-1'"
          >
            <b>{{ user.user.name }} {{ user.user.surname }}</b>
          </span>
        </div>
      </template>
      <!-- nome da primeira resposta do time -->
      <template v-slot:[`item.name`]="{ item }">
        <span class="hoverName" @click="viewAnswer(item)">{{ item.answers[0].title }}</span>
      </template>
      <!-- numero de respostas enviadas pelo time -->
      <template v-slot:[`item.replies`]="{ item }">
        <span v-if="item.answers">{{ item.answers.length }}</span>
        <span v-else>0</span>
      </template>
      <!-- numero de anexos enviadas pelo time -->
      <template v-slot:[`item.attach`]="{ item }">
        <span v-if="item.answers">{{ showAllAttachsByReply(item.answers) }}</span>
        <span v-else>0</span>
      </template>
    </v-data-table>
    <!-- Confirma deletar-->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="deleteReply"
    />
    <!-- abrir resposta -->
    <v-dialog
      v-model="openDialogReadReply"
      width="800px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <read-reply
        :reply="selectedReply"
        :collaborativeWorkAnswerId="idAnswer"
        :availableUsers="availableUsers"
        @refreshAnswers="refreshAnswers"
        @closeMessage="openDialogReadReply = false"
      />
    </v-dialog>
    <!-- ver informação do time -->
    <v-dialog
      v-model="openTeamInfo"
      width="800px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <ViewTeamInfo
        :teamInfo="teamInfo"
        :idAnswer="idAnswer"
        :availableUsers="availableUsers"
        :maxUsersByTeam="maxUsersByTeam"
        @refreshTeamData="refreshTeamData"
        @closeTeamInfo="openTeamInfo = false"
      />
    </v-dialog>
    <!-- ver anexo da resposta -->
    <v-dialog v-model="openAnswerAttachments" width="700px">
      <AnswerAttach
        :idAnswer="idAnswer"
        :answersTeam="answersByTeam"
        :availableUsers="availableUsers"
        @closeAttachments="openAnswerAttachments = false"
        @answerAddFileDone="answerAddFileDone"
      />
    </v-dialog>
  </div>
</template>

<script>
import CollaborativeWork from '../../services/collaborativeWork'
import ReadReply from '@/components/collaborativeWork/ReadReply.vue'
import ViewTeamInfo from '@/components/collaborativeWork/ViewTeam.vue'
import AnswerAttach from '@/components/collaborativeWork/AnswerAttach.vue'
export default {
  name: 'TableAnswer',
  components: {
    ReadReply,
    ViewTeamInfo,
    AnswerAttach,
  },
  props: {
    answers: {
      type: Array,
      default: () => {
        return []
      },
    },
    availableUsers: {
      type: Array,
      default: () => {
        return []
      },
    },
    idAnswer: {
      type: String,
    },
    maxUsersByTeam: {
      type: Number,
    },
    permission: { type: Boolean, default: false },
  },
  computed: {},
  data() {
    return {
      alert: {
        status: false,
        message: '',
        messageOk: 'Sim',
        messageCancel: 'Não',
      },
      userLogged: '',
      itemToDelete: {},
      openDialogReadReply: false,
      openTeamInfo: false,
      openAnswerAttachments: false,
      teamInfo: {},
      selectedReply: {},
      lastSelectedReply: '',
      answersByTeam: [],
      itemsAnswer: [],
      headers: [
        { text: 'Titulo', sortable: false, value: 'name', width: '25%', align: 'left' },
        { text: 'Equipe', sortable: false, value: 'team', width: '25%', align: 'center' },
        { text: 'Nº respostas', sortable: false, value: 'replies', width: '15%', align: 'center' },
        { text: 'Nº Anexos', sortable: false, value: 'attach', width: '15%', align: 'right' },
        { text: 'Ações', sortable: false, value: 'action', width: '20%', align: 'right' },
      ],
      headers2: [
        { text: 'Titulo', sortable: false, value: 'name', width: '31%', align: 'left' },
        { text: 'Equipe', sortable: false, value: 'team', width: '32%', align: 'center' },
        { text: 'Nº respostas', sortable: false, value: 'replies', width: '15%', align: 'center' },
        { text: 'Ações', sortable: false, value: 'action', width: '22%', align: 'right' },
      ],
    }
  },
  async created() {
    const userInfo = await this.$getItem('userInfo')
    this.userLogged = userInfo
  },
  methods: {
    resetDialogInfo() {
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', true)
    },
    checkIsVisible(item) {
      let check = false
      item.participants.forEach((user) => {
        if (user.user.id == this.userLogged.id) check = true
      })

      return check
    },
    openDelete(item) {
      this.itemToDelete = item
      this.alert.status = true
      this.alert.message = `Você deseja <b>deletar</b> a resposta?<br/><br/><span style="font-size: 0.9rem;"> <b>Título da resposta:</b> ${item.answers[0].title}<br/><b>Equipe:</b> ${item.participants[0].user.name} ${item.participants[0].user.surname}</span>`
    },
    openDialogViewTeam(item) {
      this.teamInfo = item
      this.lastSelectedReply = item._id
      this.openTeamInfo = true
    },
    openDialogAnswer() {
      console.log('clicou add resposta')
    },
    closeDialogAnswer() {
      console.log('clicou fechar resposta')
    },
    editAnswer(item) {
      console.log('clicou editar resposta')
    },
    viewAnswer(item) {
      this.selectedReply = item
      this.lastSelectedReply = item._id
      this.openDialogReadReply = true
    },
    deleteReply() {
      this.alert.status = false
      this.deleteReplyMethod()
    },
    async deleteReplyMethod() {
      this.alert.status = false
      let id = this.itemToDelete.answers[0]._id
      let teamId = this.itemToDelete._id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkDelete').id

        const ret = await CollaborativeWork.deleteAnswer(routedEntity.id, actionId, {
          answer: id, // id resposta a ser deletada
          teamId: teamId, //id time
          answerId: this.idAnswer, // id resposta trabalho colaborativo
        })
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `A <b>resposta</b> foi <b>deletada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
          this.refreshAnswers()
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Desculpe, não foi possível deletar a <b>resposta</b>.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: deleteCollaborativeWork -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    downloadAnswers() {
      this.$emit('handleDownloadAnswers')
    },
    showAllAttachsByReply(item) {
      let count = 0
      item.forEach((files) => {
        count = count + files.files.length
      })
      return count
    },
    //anexos
    viewAnswerAttachment(item) {
      /* this.idAnswer = collaborativeWorkAnswerID
         item._id = teamID
        item.answers[0]._id = id da primeira resposta do grupo   
      */
      this.answersByTeam = item
      this.openAnswerAttachments = true
    },
    refreshAnswers() {
      // console.log('recebeu refresh aviso')
      // aproveitando o método para emitir ao Collaborativework fazer novamente a requisição de respostas, para atualizar
      this.answerAddFileDone()
    },
    refreshTeamData() {
      // aproveitando o método para emitir ao Collaborativework fazer novamente a requisição de respostas, para atualizar
      this.answerAddFileDone()
    },
    answerAddFileDone() {
      //emite para o CollaborativeWork que adicionou arquivo na resposta e logo tera de fazer requisição para atualizar o prop: Answers
      this.$emit('answerAddFileDone')
    },
  },
  watch: {
    answers() {
      // para atualizar a lista de anexos a resposta, após enviar anexo a resposta
      this.answers.forEach((item) => {
        if (item._id == this.answersByTeam._id) {
          this.answersByTeam = item
          this.teamInfo = item
        }
        if (item._id == this.lastSelectedReply) {
          this.selectedReply = item
          this.teamInfo = item
        }
      })

      //atualizar ao deletar resposta aninhada
      // this.answers.forEach((item) => {
      //   if (item._id == this.lastSelectedReply) this.selectedReply = item
      // })
    },
  },
}
</script>
<style>
.hoverName:hover {
  font-weight: 500;
  text-decoration: underline #2a0845;
  cursor: pointer;
}
</style>
